unit RegDialogs;

interface

procedure Register;

implementation

uses
  ssDialogs, (* ssPasswordDlg, *) Classes, DsgnIntf, DialogsAbout;

{$R ssDialogs.DCR}

type
  TssDialogEditor = class(TComponentEditor)
  public
    { Public declarations }
    procedure Edit; override;
    function GetVerbCount: integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

(*
type
  TssPasswordDlgEditor = class(TComponentEditor)
  public
    { Public declarations }
    procedure Edit; override;
    function GetVerbCount: integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;
*)

type
  TssDialogsAboutEditor = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

{ TssDialogEditor }

procedure TssDialogEditor.Edit;
begin
  TssDialog(Component).Execute;
end;

procedure TssDialogEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecuteAbout;
    1: Edit;
    2: ;
  else
    TssDialog(Component).AddButton(TssDialogButtonKind(Index-3));
  end;
end;

function TssDialogEditor.GetVerb(Index: Integer): string;
const
  _CAPTIONS: array [TssDialogButtonKind] of string = ('OK', 'Cancel', 'Yes', 'No', 'Close', 'Abort', 'Retry', 'Ignore', 'All', 'Yes To All', 'No To All', 'Help');
begin
  case Index of
    0: Result := 'About';
    1: Result := 'Test';
    2: Result := '-';
  else
    Result := 'Add Button: '+_CAPTIONS[TssDialogButtonKind(Index-3)];
  end;
end;

function TssDialogEditor.GetVerbCount: integer;
begin
  Result := 4+Ord(HIGH(TssDialogButtonKind));
end;

{ TssDialogsAboutEditor }

procedure TssDialogsAboutEditor.Edit;
begin
  ExecuteAbout;
end;

function TssDialogsAboutEditor.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

function TssDialogsAboutEditor.GetValue: string;
begin
  Result := 'About Dialogs...';
end;

procedure Register;
begin
  RegisterComponents('Dlg', [TssDialog(*, TssPasswordDlg*)]);
  RegisterComponentEditor(TssDialog, TssDialogEditor);
//  RegisterComponentEditor(TssPasswordDlg, TssPasswordDlgEditor);
//  RegisterPropertyEditor(TypeInfo(string), TssDialog, 'About', TssDialogsAboutEditor);
end;

(*
{ TssPasswordDlgEditor }

procedure TssPasswordDlgEditor.Edit;
begin
  TssPasswordDlg(Component).Execute;
end;

procedure TssPasswordDlgEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ExecuteAbout;
    1: Edit;
  end;
end;

function TssPasswordDlgEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'About';
    1: Result := 'Test';
  end;
end;

function TssPasswordDlgEditor.GetVerbCount: integer;
begin
  Result := 2;
end;
*)

end.
